// (C) 2003 Ulrich Hecht <uli@emulinks.de>.
// Distributed under the terms of the GNU Public License v2.

/// GBA hardware specifics

#include <hardware.h>

extern "C" {
#include "vba.h"
}

#include <new>
#include <misc.h>

//#define PROFILE_VBA

void hw::init()
{
	std::set_new_handler(my_new_handler);	// install a new operator exception handler

	R_WAITCNT|=1<<14;	// enable prefetch
	R_WAITCNT|=1<<2|1<<4;	// 3/1 WS ROM timing
#ifdef PROFILE_VBA
	monstartup(0x8000000, 0x80fffff);
	moncontrol(1);	// switch off
#endif

	ham_Init();
}
