// (C) 2003 Ulrich Hecht <uli@emulinks.de>.
// Distributed under the terms of the GNU Public License v2.

#include <input.h>
#include <vbl.h>
#include <misc.h>
#include <stdlib.h>

void input::init()
{
	if(!m_instance)
	{
		m_instance=new input;
		vbl::instance()->addhandler(m_instance);
	}
}

void input::uninit()
{
	if(m_instance)
	{
		vbl::instance()->removehandler(m_instance);
		delete m_instance;
		m_instance=0;
	}
}

void input::setpos(int x, int y) {}

void input::vbl_handler()
{
	if(!m_sranded && F_CTRLINPUT_A_PRESSED)
	{
		//uprintf("srand(%d)\n", vbl::instance()->getframecount());
		srand(vbl::instance()->getframecount());	// I hope I do not need an abstraction for srand()...
		m_sranded=true;
	}
	m_action=F_CTRLINPUT_A_PRESSED;
	m_info=F_CTRLINPUT_B_PRESSED;
	m_sleft=F_CTRLINPUT_L_PRESSED;
	m_sright=F_CTRLINPUT_R_PRESSED;
	m_up=F_CTRLINPUT_UP_PRESSED;
	m_down=F_CTRLINPUT_DOWN_PRESSED;
	m_left=F_CTRLINPUT_LEFT_PRESSED;
	m_right=F_CTRLINPUT_RIGHT_PRESSED;
	m_select=F_CTRLINPUT_SELECT_PRESSED;
	m_start=F_CTRLINPUT_START_PRESSED;
}

input* input::m_instance=0;

volatile bool input::m_action;
volatile bool input::m_info;
volatile bool input::m_sleft;
volatile bool input::m_sright;
volatile bool input::m_up;
volatile bool input::m_down;
volatile bool input::m_left;
volatile bool input::m_right;
volatile bool input::m_select;
volatile bool input::m_start;
bool input::m_sranded=false;
