#!/bin/sh
# script to compile and call the map optimizer
# arg 1: map file as C code in GBA format as exported by Mappy
# arg 2: prefix to add to the identifiers
# arg 3: number of map layers
file=$1
shift
prefix=$1
shift
num=$1
nummo=$((num-1))

for i in `seq 0 $nummo`
do
    defs="$defs -DMA${i}"
done

gcc -Igba $defs -o util/gba/optimap -Wno-missing-braces -DMAPFILE=\"../${file}\" util/gba/optimap.c
util/gba/optimap $prefix $num >`dirname $file`/${prefix}_data.c
