// (C) 2003 Ulrich Hecht <uli@emulinks.de>.
// Distributed under the terms of the GNU Public License v2.

#ifndef _TUTORIAL_H
#define _TUTORIAL_H

#include "level.h"
#include "guard.h"
#include "swag.h"
#include "player.h"

/// The tutorial stage.
class tutorial : public level
{
public:
	/// The tutorial constructor
	/// \param first_bg First of two HW backgrounds used by this stage.
	tutorial(int first_bg);
	~tutorial();		///< Tutorial destructor.
	void compute(bool lowtime);

	virtual state endofstage();

private:
#include "tutorial_lvl_decl.h"

	bool hint1,	///< Hints shown yet?
		 hint2,
		 hint3;
};

#endif
